"use strict";
var _ = require('lodash');
function stripLoc(obj) {
    if (_.isArray(obj)) {
        return obj.map(stripLoc);
    }
    if (!_.isObject(obj)) {
        return obj;
    }
    var omitted = _.omit(obj, ['loc']);
    return _.mapValues(omitted, function (value) {
        return stripLoc(value);
    });
}
exports.stripLoc = stripLoc;
function printAST(fragAst) {
    console.log(JSON.stringify(stripLoc(fragAst), null, 2));
}
exports.printAST = printAST;
//# sourceMappingURL=debug.js.map