import { Store } from './store';
import { SelectionSet } from 'graphql';
export interface QueryDiffResult {
    result: any;
    missingSelectionSets: MissingSelectionSet[];
}
export interface MissingSelectionSet {
    id: string;
    typeName: string;
    selectionSet: SelectionSet;
}
export declare function diffQueryAgainstStore({store, query, variables}: {
    store: Store;
    query: string;
    variables?: Object;
}): QueryDiffResult;
export declare function diffFragmentAgainstStore({store, fragment, rootId, variables}: {
    store: Store;
    fragment: string;
    rootId: string;
    variables?: Object;
}): QueryDiffResult;
export declare function diffSelectionSetAgainstStore({selectionSet, store, rootId, throwOnMissingField, variables}: {
    selectionSet: SelectionSet;
    store: Store;
    rootId: string;
    throwOnMissingField: Boolean;
    variables: Object;
}): QueryDiffResult;
