import { NetworkInterface } from './networkInterface';
import { Store } from 'redux';
import { GraphQLResult } from 'graphql';
import { QueryManager, WatchedQueryHandle, WatchQueryOptions } from './QueryManager';
export declare class ApolloClient {
    networkInterface: NetworkInterface;
    apolloStore: Store;
    queryManager: QueryManager;
    constructor({networkInterface, apolloStore}?: {
        networkInterface?: NetworkInterface;
        apolloStore?: Store;
    });
    watchQuery(options: WatchQueryOptions): WatchedQueryHandle;
    query(options: WatchQueryOptions): Promise<GraphQLResult | Error>;
}
