"use strict";
var networkInterface_1 = require('./networkInterface');
var store_1 = require('./store');
var QueryManager_1 = require('./QueryManager');
var ApolloClient = (function () {
    function ApolloClient(_a) {
        var _b = _a === void 0 ? {} : _a, networkInterface = _b.networkInterface, apolloStore = _b.apolloStore;
        this.networkInterface = networkInterface ? networkInterface :
            networkInterface_1.createNetworkInterface('/graphql');
        this.apolloStore = apolloStore ? apolloStore : store_1.createApolloStore();
        this.queryManager = new QueryManager_1.QueryManager({
            networkInterface: this.networkInterface,
            store: this.apolloStore,
        });
    }
    ApolloClient.prototype.watchQuery = function (options) {
        return this.queryManager.watchQuery(options);
    };
    ApolloClient.prototype.query = function (options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var handle = _this.queryManager.watchQuery(options);
            handle.onResult(function (err, data) {
                var response = {};
                if (err) {
                    response.errors = err;
                }
                if (data) {
                    response.data = data;
                }
                resolve(response);
                handle.stop();
            });
        });
    };
    return ApolloClient;
}());
exports.ApolloClient = ApolloClient;
//# sourceMappingURL=index.js.map