"use strict";
require('es6-promise');
require('isomorphic-fetch');
var lodash_1 = require('lodash');
function createNetworkInterface(uri, opts) {
    if (opts === void 0) { opts = {}; }
    if (!uri) {
        throw new Error('A remote enpdoint is required for a network layer');
    }
    if (!lodash_1.isString(uri)) {
        throw new Error('Remote endpoint must be a string');
    }
    var _uri = uri;
    var _opts = lodash_1.assign({}, opts);
    function fetchFromRemoteEndpoint(request) {
        return fetch(uri, lodash_1.assign({}, _opts, {
            body: JSON.stringify(request),
            headers: lodash_1.assign({}, _opts.headers, {
                Accept: '*/*',
                'Content-Type': 'application/json',
            }),
            method: 'POST',
        }));
    }
    ;
    function query(request) {
        return fetchFromRemoteEndpoint(request)
            .then(function (result) { return result.json(); })
            .then(function (payload) {
            if (!payload.hasOwnProperty('data') && !payload.hasOwnProperty('errors')) {
                throw new Error("Server response was missing for query '" + request.debugName + "'.");
            }
            else {
                return payload;
            }
        });
    }
    ;
    return {
        _uri: _uri,
        _opts: _opts,
        query: query,
    };
}
exports.createNetworkInterface = createNetworkInterface;
//# sourceMappingURL=networkInterface.js.map