"use strict";
var parser_1 = require('./parser');
var diffAgainstStore_1 = require('./diffAgainstStore');
function readQueryFromStore(_a) {
    var store = _a.store, query = _a.query, variables = _a.variables;
    var queryDef = parser_1.parseQuery(query);
    return readSelectionSetFromStore({
        store: store,
        rootId: 'ROOT_QUERY',
        selectionSet: queryDef.selectionSet,
        variables: variables,
    });
}
exports.readQueryFromStore = readQueryFromStore;
function readFragmentFromStore(_a) {
    var store = _a.store, fragment = _a.fragment, rootId = _a.rootId, variables = _a.variables;
    var fragmentDef = parser_1.parseFragment(fragment);
    return readSelectionSetFromStore({
        store: store,
        rootId: rootId,
        selectionSet: fragmentDef.selectionSet,
        variables: variables,
    });
}
exports.readFragmentFromStore = readFragmentFromStore;
function readSelectionSetFromStore(_a) {
    var store = _a.store, rootId = _a.rootId, selectionSet = _a.selectionSet, variables = _a.variables;
    var result = diffAgainstStore_1.diffSelectionSetAgainstStore({
        selectionSet: selectionSet,
        rootId: rootId,
        store: store,
        throwOnMissingField: true,
        variables: variables,
    }).result;
    return result;
}
exports.readSelectionSetFromStore = readSelectionSetFromStore;
//# sourceMappingURL=readFromStore.js.map