import { SelectionSet } from 'graphql';
export interface Store {
    [dataId: string]: StoreObject;
}
export interface StoreObject {
    __typename?: string;
    [storeFieldKey: string]: StoreValue;
}
export declare type StoreValue = number | string | string[];
export declare const QUERY_RESULT_ACTION: string;
export declare function createQueryResultAction({result, selectionSet, variables}: {
    result: any;
    selectionSet: SelectionSet;
    variables: Object;
}): QueryResultAction;
export interface QueryResultAction {
    type: string;
    result: any;
    selectionSet: SelectionSet;
    variables: Object;
}
export declare type ApolloAction = QueryResultAction;
export declare function createApolloStore(): Redux.Store;
export declare function resultCacheReducer(previousState: Store, action: ApolloAction): Store;
