"use strict";
var redux_1 = require('redux');
var lodash_1 = require('lodash');
var writeToStore_1 = require('./writeToStore');
exports.QUERY_RESULT_ACTION = 'QUERY_RESULT';
function createQueryResultAction(_a) {
    var result = _a.result, selectionSet = _a.selectionSet, variables = _a.variables;
    return {
        type: exports.QUERY_RESULT_ACTION,
        result: result,
        selectionSet: selectionSet,
        variables: variables,
    };
}
exports.createQueryResultAction = createQueryResultAction;
var crashReporter = function (store) { return function (next) { return function (action) {
    try {
        return next(action);
    }
    catch (err) {
        console.error('Caught an exception!', err);
        console.error(err.stack);
        throw err;
    }
}; }; };
function createApolloStore() {
    var enhancers = [];
    if (typeof window !== 'undefined') {
        var anyWindow = window;
        if (anyWindow.devToolsExtension) {
            enhancers.push(anyWindow.devToolsExtension());
        }
    }
    enhancers.push(redux_1.applyMiddleware(crashReporter));
    return redux_1.createStore(resultCacheReducer, redux_1.compose.apply(void 0, enhancers));
}
exports.createApolloStore = createApolloStore;
function resultCacheReducer(previousState, action) {
    if (previousState === void 0) { previousState = {}; }
    switch (action.type) {
        case exports.QUERY_RESULT_ACTION:
            var clonedState = lodash_1.assign({}, previousState);
            var newState = writeToStore_1.writeSelectionSetToStore({
                result: action.result,
                selectionSet: action.selectionSet,
                variables: action.variables,
                store: clonedState,
            });
            return newState;
        default:
            return previousState;
    }
}
exports.resultCacheReducer = resultCacheReducer;
//# sourceMappingURL=store.js.map