"use strict";
var chai_1 = require('chai');
var queryPrinting_1 = require('../src/queryPrinting');
describe('printing queries', function () {
    it('converts selection set to a query string', function () {
        var id = 'lukeId';
        var typeName = 'Person';
        var selectionSet = {
            kind: 'SelectionSet',
            selections: [
                {
                    'kind': 'Field',
                    'alias': null,
                    'arguments': [],
                    'directives': [],
                    'name': {
                        'kind': 'Name',
                        'value': 'age',
                    },
                    'selectionSet': null,
                },
            ],
        };
        chai_1.assert.equal(queryPrinting_1.printQueryForMissingData([
            {
                id: id,
                typeName: typeName,
                selectionSet: selectionSet,
            },
        ]), "{\n  __node_0: node(id: \"lukeId\") {\n    id\n    ... on Person {\n      age\n    }\n  }\n}\n");
    });
});
//# sourceMappingURL=queryPrinting.js.map